'''
Created on 2013-07-29

@author: Jackie
'''
from utilities.io import cmdline_io
from dseval.sigtest import paired_wilcoxon_sigtest
from dseval.qa import compute_norm_ranks
import numpy as np

def print_help():
    print 'Evaluating distributional semantics by restricted QA'
    print '''
    Author: Jackie Chi Kit Cheung
    jcheung@cs.toronto.edu
    
    --Input Format--
    Please see README.txt or examples for more details.
    
    --Usage--
    (1) To compute the mean rank scores:
    python ./qa_eval.py -t evaluate -i <input file> [Optional: -j <output of overlap>]
    
    (2) To perform a paired Wilcoxon signed rank test
    python ./qa_eval.py -t sigtest -i <input file 1> -j <input file 2>
    
    Both usages write to standard output, and also write debug output to standard error.
    Other options:
    -h             Print this help message
    '''
    exit()
    
if __name__ == '__main__':
    params, c = cmdline_io('hi:j:t:', print_help, default_config = None)
    task = params['-t']
    
    if task == 'evaluate':
        norm_ranks, mrank = compute_norm_ranks(params['-i'])
        print norm_ranks
        print mrank
        
        if '-j' in params:
            o_ranks, o_mrank = compute_norm_ranks(params['-j'])
            filtered_ranks = np.array(norm_ranks)[np.array(o_ranks) < 1.0]
            filtered_mrank = np.mean(filtered_ranks)
            print str(list(filtered_ranks))
            print filtered_mrank
            print 'Mean rank\t%.4f' % mrank
            print 'Overlap mean rank\t%.4f' % o_mrank
            print '# Overlap not perfect\t%d' % len(filtered_ranks) 
            print 'Mean rank where overlap not perfect\t%.4f' % filtered_mrank
        
        else:
            print
            print
            print 'Mean rank\t%.4f' % mrank
        
        
        
            
             
    elif task == 'sigtest':
        paired_wilcoxon_sigtest(params['-i'], params['-j'])